<!doctype html>
<html lang="en">

	<head>
		<meta charset="utf-8">

		<title>RHPAM DevOps Workshop</title>

		<meta name="description" content="DevOps Testing">
		<meta name="author" content="Eric D. Schabell">

		<meta name="apple-mobile-web-app-capable" content="yes" />
		<meta name="apple-mobile-web-app-status-bar-style" content="black-translucent" />

		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<link rel="stylesheet" href="css/reveal.min.css">
        <link rel="stylesheet" href="css/theme/redhat.css" id="theme">

		<!-- For syntax highlighting -->
		<link rel="stylesheet" href="lib/css/zenburn.css">

		<!-- If the query includes 'print-pdf', include the PDF print sheet -->
		<script>
			if( window.location.search.match( /print-pdf/gi ) ) {
				var link = document.createElement( 'link' );
				link.rel = 'stylesheet';
				link.type = 'text/css';
				link.href = 'css/print/pdf.css';
				document.getElementsByTagName( 'head' )[0].appendChild( link );
			}
		</script>

		<!--[if lt IE 9]>
		<script src="lib/js/html5shiv.js"></script>
		<![endif]-->
	</head>

	<body>

		<div class="reveal">

			<!-- Any section element inside of this container is displayed as a slide -->
			<div class="slides">
                <section>
                    <h3>Lab 8 - Running the process</h3>
				</section>

                <section>
                    <div style="width: 1056px; height: 200px;">
                        <h2>Lab goal</h2>
                        <h4>To build, deploy, and complete process including task forms for devops testing job. We
                        want to run both a happy-path and a job that fails, ensuring coverage of all possible paths.</h4>
                    </div>
                    <div style="width: 1056px; height: 600px;">
                        <img style="border: 0px" src="images/rhpam-component-processtaskmanagement.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Process run plan</h2>
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        Time to run our new devops testing process by submitting three different jobs (but you can do more!):
                    </div>
                    <div style="width: 1056px; height: 300px; text-align: left">
                        <ul>
                            <li>lines of code = 50 (up to 50, rules decide no peer review)</li>
                            <li>lines of code > 50 (rules decide peer review needed and user task approves job)</li>
                            <li>lines of code > 50 (rules decide peer review needed and user task rejects job)</li>
                        </ul>
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Deploying project</h2>
                    </div>
                    <div style="width: 1056px; height: 80px; text-align: left">
                        Now let's deploy the devops testing project:
                    </div>
                    <div style="width: 1056px; height:200px; text-align: left">
                        <ul>
                            <li>click on top right <code>DEPLOY</code> button</li>
                            <li>If all goes well you'll see a green pop-ups verifying the deployment</li>
                            <li>Note that deploying also triggers a build</li>
                        </ul>
                    </div>
                    <div style="width: 1056px; height: 600px;">
                        <img src="images/image8-1.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Examine process definition</h2>
                    </div>
                    <div style="width: 1056px; height: 80px; text-align: left">
                        Let's take a look at the process definition deployment:
                    </div>
                    <div style="width: 1056px; height: 80px; text-align: left">
                        <ul>
                            <li>select via top <code>Menu -> Manage -> Process Definitions</code></li>
                        </ul>
                    </div>
                    <div style="width: 1056px; height: 300px;">
                        <img src="images/image8-2.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Examine process definition</h2>
                    </div>
                    <div style="width: 1056px; height: 200px; text-align: left">
                        This opens the Manage view pane where you'll see our devops testing process definition.
                        Later you can use the drop-down menu at the top to jump between different views. We're going
                        to open the process definition by clicking on it:
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-3.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Starting first run</h2>
                    </div>
                    <div style="width: 1056px; height: 120px; text-align: left">
                        Our first process we want to run a job with 50 lines of code and it should proceed down
                        the happy-path like this (greyed out nodes indicate processed path):
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-4.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Starting a process instance</h2>
                    </div>
                    <div style="width: 1056px; height: 120px; text-align: left">
                        This view offers choice of definition details or image of the process. Start a new process
                        instance by clicking on the button top right corner <i>New Process Instance</i>:
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-5.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Start process form</h2>
                    </div>
                    <div style="width: 1056px; height: 80px; text-align: left">
                        You'll see your designed start form pop-up, add data (ensure lines of code is set to 50)
                        and <i>SUBMIT</i>:
                    </div>
                    <div style="width: 1056px; height: 450px;">
                        <img src="images/image8-6.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                    <h2>Process instance details</h2>
                </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        A green pop-up displayed the process id, now note the <i>Instance State</i> is completed:
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-7.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Process instance diagram</h2>
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        Select the <i>Diagram</i> tab for visual status of the completed process instance. This is
                        exactly what we expect for lines of code = 50:
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-8.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Starting second run</h2>
                    </div>
                    <div style="width: 1056px; height: 170px; text-align: left">
                        Our second process we want to run a job with more than 50 lines of code and it should proceed down
                        the path requiring peer review user task, which we'll approve like this (greyed out nodes
                        indicate processed path):
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-9.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Starting a process instance</h2>
                    </div>
                    <div style="width: 1056px; height: 120px; text-align: left">
                        Go back to the process definition details and start a new process instance by clicking on
                        the button top right corner <i>New Process Instance</i>:
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-5.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Start process form</h2>
                    </div>
                    <div style="width: 1056px; height: 80px; text-align: left">
                        You'll see your designed start form pop-up, add data (ensure lines of code is set to 51)
                        and <i>SUBMIT</i>:
                    </div>
                    <div style="width: 1056px; height: 450px;">
                        <img src="images/image8-10.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Process instance details</h2>
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        A green pop-up displayed the process id, now note the <i>Instance State</i> is <i>ACTIVE</i>:
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-11.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Process instance diagram</h2>
                    </div>
                    <div style="width: 1056px; height: 120px; text-align: left">
                        Select the <i>Diagram</i> tab for visual status of process instance. It's exactly what
                        we expect for lines of code = 51, the rules check requires a peer review (red box indicates
                        location):
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-12.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>View task inbox</h2>
                    </div>
                    <div style="width: 1056px; height: 80px; text-align: left">
                        To find our peer review task we need to look in our task inbox:
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        <ul>
                            <li>navigate by clicking on top <code>MENU</code></li>
                            <li>under Track click on <code>Task inbox</code></li>
                        </ul>
                    </div>
                    <div style="width: 1056px; height: 600px;">
                        <img src="images/image8-13.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Task inbox</h2>
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        The task inbox has your <i>Peer Review</i> task listed, just click on task entry to open:
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-14.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Claim task</h2>
                    </div>
                    <div style="width: 1056px; height: 150px; text-align: left">
                        The task form for <i>Peer Review</i> is presented and before you can work on it you need
                        to <i>Claim</i> it, removing it from the queue so other <i>Managers</i> can't work on it:
                    </div>
                    <div style="width: 1056px; height: 10px; text-align: left">
                        <ul>
                            <li>click on <code>CLAIM</code></li>
                        </ul>
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-15.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Start task</h2>
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        The task is now ready for the next stage, so click on <i>START</i> to being the task and
                        make the form editable:
                    </div>
                    <div style="width: 1056px; height: 450px;">
                        <img src="images/image8-16.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Complete task</h2>
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        Time to evaluate the form data and process this task by marking it approved:
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        <ul>
                            <li>check the box <code>Approval</code></li>
                            <li>submit with <code>Complete</code></li>
                        </ul>
                    </div>
                    <div style="width: 1056px; height: 600px;">
                        <img src="images/image8-17.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Remove task filters</h2>
                    </div>
                    <div style="width: 1056px; height: 80px; text-align: left">
                        The task is no longer in the inbox. That's due to the filters at the top, so let's remove them
                        to view completed task:
                    </div>
                    <div style="width: 1056px; height: 500px; text-align: left">
                        <img src="images/image8-18.png">
                        <img src="images/image8-19.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Review process instance</h2>
                    </div>
                    <div style="width: 1056px; height: 80px; text-align: left">
                        If all went well our process instance is completed, so let's check:
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        <ul>
                            <li>open the process instance list by clicking on button <code>View process</code></li>
                        </ul>
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-20.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Review process instance</h2>
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        Open the <i>Diagram</i> tab and view the diagram of the completed process instance, it should
                        look like this:
                    </div>
                    <div style="width: 1056px; height: 450px;">
                        <img src="images/image8-21.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Starting final run</h2>
                    </div>
                    <div style="width: 1056px; height: 170px; text-align: left">
                        Our final process run is a job with more than 50 lines of code and it should proceed down
                        the path requiring peer review user task, which we'll reject like this (greyed out nodes
                        indicate processed path):
                    </div>
                    <div style="width: 1056px; height: 370px;">
                        <img src="images/image8-22.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Starting a process instance</h2>
                    </div>
                    <div style="width: 1056px; height: 120px; text-align: left">
                        Go back to the process definition details and start a new process instance by clicking on
                        the button top right corner <i>New Process Instance:</i>
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-5.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Start process form</h2>
                    </div>
                    <div style="width: 1056px; height: 80px; text-align: left">
                        You'll see your designed start form pop-up, add data (ensure lines of code is larger than 50)
                        and <i>SUBMIT</i>:
                    </div>
                    <div style="width: 1056px; height: 450px;">
                        <img src="images/image8-23.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Process instance details</h2>
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        A green pop-up displayed the process id, now note the <i>Instance State</i> is <i>ACTIVE</i>:
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-24.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Process instance diagram</h2>
                    </div>
                    <div style="width: 1056px; height: 120px; text-align: left">
                        Select the <i>Diagram</i> tab for visual status of process instance. It's exactly what
                        we expect for lines of code = 100, the rules check requires a peer review (red box indicates
                        location):
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-25.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>View task inbox</h2>
                    </div>
                    <div style="width: 1056px; height: 80px; text-align: left">
                        To find our peer review task we need to look in our task inbox:
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        <ul>
                            <li>navigate by clicking on top <code>MENU</code></li>
                            <li>under Track click on <code>Task inbox</code></li>
                        </ul>
                    </div>
                    <div style="width: 1056px; height: 600px;">
                        <img src="images/image8-13.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Task inbox</h2>
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        The task inbox has your <i>Peer Review</i> task listed, just click on task entry to open:
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-14.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Claim and start task</h2>
                    </div>
                    <div style="width: 1056px; height: 60px; text-align: left">
                        Let's take task <i>Peer Review</i> and click through <i>CLAIM, START</i>:
                    </div>
                    <div style="width: 1056px; height: 470px;">
                        <img src="images/image8-26.png">
                        <img src="images/image8-27.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Complete task</h2>
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        Time to evaluate the form data and process this task as not approved:
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        <ul>
                            <li>do <b>NOT</b> check the box <code>Approval</code></li>
                            <li>submit with <code>Complete</code></li>
                        </ul>
                    </div>
                    <div style="width: 1056px; height: 600px;">
                        <img src="images/image8-28.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Remove task filters</h2>
                    </div>
                    <div style="width: 1056px; height:120px; text-align: left">
                        The task is no longer in the inbox. That's due to the filters at the top, so let's remove them
                        to view completed tasks (note there are a few listed):
                    </div>
                    <div style="width: 1056px; height: 500px; text-align: left">
                        <img src="images/image8-29.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Review process instance</h2>
                    </div>
                    <div style="width: 1056px; height: 80px; text-align: left">
                        If all went well our process instance is completed, so let's check:
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        <ul>
                            <li>open the process instance list by clicking on button <code>View process</code></li>
                        </ul>
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-20.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Review process instance</h2>
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        Open the <i>Diagram</i> tab and view the diagram of the completed process instance, it should
                        look like this:
                    </div>
                    <div style="width: 1056px; height: 450px;">
                        <img src="images/image8-30.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Log verification</h2>
                    </div>
                    <div style="width: 1056px; height: 80px; text-align: left">
                        To verify the logging, see <i>Logs</i> tab, but it's business level logging only:
                    </div>
                    <div style="width: 1056px; height: 450px;">
                        <img src="images/image8-31.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Real log verification</h2>
                    </div>
                    <div style="width: 1056px; height: 80px; text-align: left">
                        Let's check the server logs, back in the console used to start from:
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        <ul>
                            <li>we see there the entire run of our process including the logging</li>
                            <li>the second part is after user task peer review completed</li>
                        </ul>
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-32.png">
                        <img src="images/image8-33.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>Lab sub-goal</h2>
                        <h4>To view and explore available process and task reports</h4>
                    </div>
                    <div style="width: 1056px; height: 600px;">
                        <img style="border: 0px" src="images/rhpam-component-reports.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>View process reports</h2>
                    </div>
                    <div style="width: 1056px; height: 60px; text-align: left">
                        Data gathering from processes and tasks can be found in reports:
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left">
                        <ul>
                            <li>open <code>Menu -> Track -> Process Reports</code></li>
                            <li>initial process reports lack data, explore now for reference</li>
                        </ul>
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-34.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 150px;">
                        <h2>View task reports</h2>
                    </div>
                    <div style="width: 1056px; height: 60px; text-align: left;">
                        Let's look at the task reports:
                    </div>
                    <div style="width: 1056px; height: 100px; text-align: left;">
                        <ul>
                            <li>Now open <code>Menu -> Track -> Task Reports</code></li>
                            <li>Feel free to start and complete more process instances</li>
                        </ul>
                    </div>
                    <div style="width: 1056px; height: 400px;">
                        <img src="images/image8-35.png">
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 250px;">
                        <h2>Process Automation Manager</h2>
                        <h3>Up next...</h3>
                    </div>
                    <div style="width: 1056px; height: 300px;">
                        <!-- <h3><a href="lab09.html" target="_blank">Lab 9 - Automated task reassignment</a></h3> -->
                        <h3>The end, or is it?</h3>
                        <h3>(stay tuned...)</h3>
                    </div>
                </section>

                <section data-background="images/rh-images/rh-bg-grey.png" data-background-position="top">
                    <div style="width: 1056px; height: 300px;" align="left">
                        <h2>QUESTIONS?</h2>
                    </div>
                    <div style="width: 1056px; height: 100px;" align="right">
                        <div style="width: 500px; height: 100px;" align="left">
                            Eric D. Schabell<br>
                            Global Technology Evangelist & Portfolio Architect Director<br>
                            <a href="http://twitter.com/ericschabell" target="_blank">@ericschabell</a><br>
                            <a href="http://schabell.org" target="_blank">http://schabell.org</a>
                        </div>
                    </div>
                </section>

                <section>
                    <div style="width: 1056px; height: 200px; text-align: left">
                        <img height="150" width="100%" src="images/references.jpg">
                    </div>
                    <div style="width: 1056px; height: 400px; text-align: left">
                        More workshops: <br/>
                        <ul style="font-size: smaller">
                            <li><a href="https://learn.katacoda.com/mfentanes/courses/rhpam-7-workshop" target="_blank">Process automation workshops (by MyriamJ)</a></li>
                        </ul>
                        <br><br>
                        More reading:<br/>
                        <ul style="font-size: smaller">
                            <li><a href="http://www.schabell.org/search/label/Process%20Automation%20Manager" target="_blank">Process automation blog</a></li>
                            <li><a href="http://bit.ly/effective-jboss-bpm" target="_blank">Effective business processs management with JBoss BPM (free book)</a></li>
                        </ul>
                        <br><br>
                        More demo projects:<br/>
                        <ul style="font-size: smaller">
                            <li><a href="https://gitlab.com/bpmworkshop" target="_blank">Workshop demos</a></li>
                            <li><a href="https://gitlab.com/redhatdemocentral" target="_blank">AppDev in the cloud demos</a></li>
                        </ul>
                    </div>
                </section>
            </div>
		</div>

		<script src="lib/js/head.min.js"></script>
		<script src="js/reveal.min.js"></script>

		<script>

			// Full list of configuration options available here:
			// https://github.com/hakimel/reveal.js#configuration
			Reveal.initialize({
				controls: true,
				progress: true,
				history: true,
				center: true,

				theme: Reveal.getQueryHash().theme, // available themes are in /css/theme
				transition: Reveal.getQueryHash().transition || 'default', // default/cube/page/concave/zoom/linear/fade/none

				// Parallax scrolling
				// parallaxBackgroundImage: 'https://s3.amazonaws.com/hakim-static/reveal-js/reveal-parallax-1.jpg',
				// parallaxBackgroundSize: '2100px 900px',

				// Optional libraries used to extend on reveal.js
				dependencies: [
					{ src: 'lib/js/classList.js', condition: function() { return !document.body.classList; } },
					{ src: 'plugin/markdown/marked.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
					{ src: 'plugin/markdown/markdown.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
					{ src: 'plugin/highlight/highlight.js', async: true, callback: function() { hljs.initHighlightingOnLoad(); } },
					{ src: 'plugin/zoom-js/zoom.js', async: true, condition: function() { return !!document.body.classList; } },
					{ src: 'plugin/notes/notes.js', async: true, condition: function() { return !!document.body.classList; } }
				]
			});

		</script>

	</body>
</html>
